# -*- coding: utf-8 -*-
"""
Created on Fri Apr 12 14:15:56 2024

@author: vlandgraf
"""

# -*- coding: utf-8 -*-
"""
Created on Fri Apr 12 13:44:25 2024

@author: vlandgraf
"""

# -*- coding: utf-8 -*-
"""
Created on Wed Apr 10 09:31:33 2024

@author: vlandgraf
"""

import Import_file_for_LSN_8_8_8 as LSN_functions
from functools import partial
from concurrent.futures import ProcessPoolExecutor
import time
import sys
import pickle as pkl
import shelve 
import rustworkx as rx
import numpy as np 
from Import_file_for_LSN_8_8_8 import  x_zero, x_one,  x_one_to_zero, y_zero, y_one, y_one_to_zero, z_zero, z_one, z_one_to_zero
import random 

tet_boundary = LSN_functions.tet_boundaries
num_atoms = LSN_functions.num_of_atoms
oct_tet_keys = LSN_functions.oct_tet_keys
anions_surrounding = LSN_functions.anions_surrounding

with open('/scratch/vlandgraf/Lithium_Notrode_Sulfifes/New_percolation_study/jump_lib_with_errors_DISORDERED.pkl', 'rb') as h:
    jump_lib = pkl.load(h)    

def invert_dictionary(input_dict): 
    return {v:k for k,v in input_dict.items()}
    
x_zero_to_one = invert_dictionary(x_one_to_zero)
y_zero_to_one = invert_dictionary(y_one_to_zero)
z_zero_to_one = invert_dictionary(z_one_to_zero)
 
# For one Graph        
def analyse_percolation_through_one_supercell(combined_dict, target_ea):
    fraction_connected_sites_list, probability_of_connection_list = [], []
    for _ in range(50):
        G = rx.PyGraph()
        list_of_eas  = {k: random.choice(np.arange(v['average_ea']-v['error_in_ea'], v['average_ea']+v['error_in_ea'], 0.025)) for k,v in jump_lib.items()}
        for i in range(num_atoms): 
            G.add_node(i)
        for k in LSN_functions.jump_keys_one_way:
            jump_type_precise = combined_dict[k]['jump_type_precise']
            test_ea = list_of_eas[jump_type_precise]

            if test_ea < target_ea:
                jump_type_precise = combined_dict[k[::-1]]['jump_type_precise']
                test_ea = list_of_eas[jump_type_precise]

            
                if test_ea < target_ea:
                    G.add_edge(*k, k)
    
        def test_node_connectivity(node, image_node_list): 
            for image_node in image_node_list: 
                if rx.has_path(G, node, image_node): 
                    return True
                else:
                    pass
            return False
        
        def test_node_connectivity_with_periodicity(node, image_node_list, one_to_zero, tracker=[], tracker_disconnected=[], zero_nodes_connected=[], disconnected_zero_nodes=[]): 
            for image_node in image_node_list: 
                if rx.has_path(G, node, image_node): 
                    if one_to_zero[image_node] in tracker or zero_nodes_connected: 
                        tracker.append(node)
                        zero_nodes_connected.extend(tracker)
                        return True, list(set(zero_nodes_connected)), list(set(disconnected_zero_nodes))
                    elif one_to_zero[image_node] in disconnected_zero_nodes:
                        pass
                    else:
                        tracker.append(node)
                        tracker_disconnected.append(node)
                        node = one_to_zero[image_node]
                        return test_node_connectivity_with_periodicity(node, image_node_list, one_to_zero, tracker, tracker_disconnected, zero_nodes_connected, disconnected_zero_nodes)
                        
            disconnected_zero_nodes.extend(tracker_disconnected + [node])
            return False, list(set(zero_nodes_connected)), list(set(disconnected_zero_nodes))
        
        def check_if_path_to_any(test_node, list_to_test): 
            for target in list_to_test:
                if rx.has_path(G, test_node, target):
                    return True
                else:
                    pass
            return False
        
        def test_connectitivity_of_node_list(node_list, image_node_list, one_to_zero, zero_nodes_connected=[], disconnected_zero_nodes=[]):
            for node in node_list:
                if node in zero_nodes_connected:
                    pass
                elif check_if_path_to_any(node, zero_nodes_connected):
                    zero_nodes_connected.append(node)      
                else:
                    _, zero_nodes_connected, disconnected_zero_nodes = test_node_connectivity_with_periodicity(node, image_node_list, one_to_zero, zero_nodes_connected=zero_nodes_connected, disconnected_zero_nodes=disconnected_zero_nodes, tracker=[], tracker_disconnected=[])
                    for dis_node in disconnected_zero_nodes:
                        if check_if_path_to_any(dis_node, zero_nodes_connected): 
                            zero_nodes_connected.append(dis_node)
                            disconnected_zero_nodes.remove(dis_node)
            return list(set(zero_nodes_connected)), list(set(disconnected_zero_nodes))
                    
        (connected_xnodes, dis_xnodes) = test_connectitivity_of_node_list(x_zero, x_one, x_one_to_zero, zero_nodes_connected=[], disconnected_zero_nodes=[])
        (connected_ynodes, dis_ynodes) = test_connectitivity_of_node_list(y_zero, y_one, y_one_to_zero, zero_nodes_connected=[], disconnected_zero_nodes=[])
        (connected_znodes, dis_znodes) = test_connectitivity_of_node_list(z_zero, z_one, z_one_to_zero, zero_nodes_connected=[], disconnected_zero_nodes=[])
        
        all_nodes = np.array(range(tet_boundary[1]))
        total_list_of_boundary_nodes = np.array(list(x_one) + list(y_one) + list(z_one) + list(x_zero) + list(y_zero) + list(z_zero))
        bulk_nodes = [element for element in all_nodes if element not in total_list_of_boundary_nodes]
        
        connected_x_images = [x_zero_to_one[i] for i in connected_xnodes]
        connected_y_images = [y_zero_to_one[i] for i in connected_ynodes]
        connected_z_images = [z_zero_to_one[i] for i in connected_znodes]
        
        connected_nodes_total = connected_xnodes + connected_ynodes + connected_znodes + connected_x_images + connected_y_images + connected_z_images
        connected_nodes_total = list(set(connected_nodes_total))
        
        for bulk_node in bulk_nodes:
            if check_if_path_to_any(bulk_node, connected_nodes_total):
                connected_nodes_total.append(bulk_node)
            else:
                pass
        
        fraction_connected_sites_list.append(len(connected_nodes_total) / tet_boundary[1])
        probability_of_connection_list.append(len(G.edges()) / len(LSN_functions.jump_keys_one_way))
    
    return fraction_connected_sites_list, probability_of_connection_list
